A [node](http://nodejs.org) module to chain multiple configurable commands, run them in a predefined order and access their results afterwards.

## Installation

```bash
$ npm install macro-command
```

## Features

  * Run commands in sync
  * Promise based
  * Command pattern
  * Namespace support
  * Highly configurable & flexible

## Docs
  * [Github repo](https://github.com/ruckola/macro-command)
  * [Demo project](https://github.com/ruckola/mcdemo) - See the macro-command in action.
  * [Use-case](http://ruckola.com/2017/02/11/use-case-for-the-macro-command-module/) - Read more about this package.
  * [Youtube tutorials] (https://www.youtube.com/playlist?list=PLHNUoYWjoYsJLgdL6pGQYUsKRKrt1pNGL)
   
### To build the documentation for the macro-command module:
 Open a command prompt and go to the root of the application. Then run the following command:
```bash
$ .\node_modules\.bin\jsdoc .\node_modules\macro-command -r -d mc-docs
 ```
 This will create a directory called "mc-docs" in the root directory of your application. After the build has completed, it contains a lot of files. Just open the index.html in your webbrowser to view the documentation.
 Note: If the build fails, you probably need to run npm install first. This will install JSDOC. After the installation has completed try to build the documentation again

## Tests

  To run the test suite, first install the dependencies, then run `npm test`:

```bash
$ npm install
$ npm test
```

## Examples

  To view some examples, clone the mcdemo repo and install the dependencies:

```bash
$ git clone https://github.com/ruckola/mcdemo.git
$ cd mcdemo
$ npm install
```

  Then run one of the example apps:

```bash
$ node app-single-mode.js
$ node app-macro-mode1.js
$ node app-macro-mode2.js
```